DECLARE SUB TwoColr (Attr%)
DECLARE SUB PrintHeader ()
DECLARE SUB Compress ()
DECLARE SUB Progress (Counter&, maximum&)
DECLARE SUB Compress2 ()

'  ͻ
'     Created     :  December 4, 1994 for C                               
'     Created     :  December 28, 1994 for QuickBasic                     
'     Updated     :  January 16, 1995                                     
'     By          :  Anthony D'Agostino  72650,2377                       
'     Description :  Compresses a TGA file with RLE                       
'  ͼ

TStart = TIMER
CLS

TYPE tgaheader
  idlen         AS INTEGER
  tgatype       AS INTEGER
  reserveda     AS LONG
  reservedb     AS LONG
  xres          AS INTEGER
  yres          AS INTEGER
  bitsperpix    AS STRING * 1
  descriptor    AS STRING * 1
END TYPE
DIM SHARED thdr AS tgaheader

CONST FALSE = 0, TRUE = NOT FALSE

'
IF LEN(COMMAND$) THEN
   firstspace = INSTR((COMMAND$), " ")
   IF (firstspace = 0) THEN
      firstspace = (LEN(COMMAND$))
      PRINT "Enter second filename on Command line."
      END
   END IF
   tgafileI$ = LEFT$(COMMAND$, firstspace - 1)
   tgafileO$ = RIGHT$(COMMAND$, (LEN(COMMAND$) - firstspace))
   tgafileI$ = tgafileI$ + ".TGA"
   tgafileO$ = tgafileO$ + ".TGA"
ELSE
   TwoColr 75
   PRINT "!Copyright (!C) 1995, Anthony D'Agostino"; SPACE$(29); " 72650,2377"
   TwoColr 7
   PRINT "Version 1.0", "This program is freeware"
   PRINT "Compress 24 bit TGA files with simple Run Length Encoding."
   PRINT
   PRINT "Syntax: QRLE [infile] [outfile]"
   PRINT "Don't type the extension."
   PRINT
   END
END IF
'

SHELL "IF EXIST " + tgafileO$ + " DEL " + tgafileO$ + " > NUL"

OPEN tgafileI$ FOR BINARY ACCESS READ AS #1
OPEN tgafileO$ FOR BINARY ACCESS WRITE AS #2

IF LOF(1) = 0 THEN
   PRINT "File "; UCASE$(tgafileI$); " not found."
   CLOSE #1: KILL tgafileI$:
   CLOSE #1: KILL tgafileO$:
   BEEP: END
END IF

'

GET #1, , thdr
   CALL PrintHeader
   thdr.tgatype = 10       ' type 10 = RLE compressed
PUT #2, , thdr

CALL Compress        ' Faster method
'CALL Compress2       ' Slower method

'
TwoColr 7
TEnd = TIMER
PRINT : PRINT : PRINT

PRINT USING "#########,"; LOF(1); : PRINT , "Size of "; tgafileI$
PRINT USING "#########,"; LOF(2); : PRINT , "Size of "; tgafileO$
PRINT USING "#######.##%"; LOF(2) / LOF(1) * 100; : PRINT , "Ratio"
PRINT

IF (TEnd - TStart) > 60 THEN
   PRINT (TEnd - TStart) \ 60; "min";
   PRINT (TEnd - TStart) MOD 60; "sec";
ELSE
   PRINT (TEnd - TStart); "seconds to complete"
END IF



CLOSE
SOUND 3000, 2
SYSTEM
END

SUB Compress
   'CONST DEBUG = TRUE
   DIM RunLen AS LONG
   DIM PixCnt AS LONG
   PixelA$ = SPACE$(3)
   PixelB$ = SPACE$(3)

   GET #1, , PixelA$

   DO
      RunLen = RunLen + 1
      PixCnt = PixCnt + 1
     
      CALL Progress(PixCnt, 1& * thdr.xres * thdr.yres)

      GET #1, , PixelB$

      IF PixelB$ <> PixelA$ OR EOF(1) THEN
         IF RunLen <= 128 THEN
            RL$ = CHR$(RunLen + 127)
               IF DEBUG THEN PRINT "Less", ASC(RL$), PixCnt, RunLen
            PUT #2, , RL$: PUT #2, , PixelA$
         ELSE
            FOR i = 1 TO RunLen \ 128
               RL$ = CHR$(255)
                  IF DEBUG THEN PRINT ">", ASC(RL$), PixCnt, RunLen
               PUT #2, , RL$: PUT #2, , PixelA$
            NEXT
            IF RunLen MOD 128 THEN
               RL$ = CHR$((RunLen MOD 128) + 127)
                  IF DEBUG THEN PRINT "Mod", ASC(RL$), PixCnt, RunLen
               PUT #2, , RL$: PUT #2, , PixelA$
            END IF
         END IF
         RunLen = 0
      END IF

      PixelA$ = PixelB$
   LOOP WHILE PixCnt < 1& * thdr.xres * thdr.yres
END SUB

SUB Compress2
   'CONST DEBUG = TRUE
   DIM RunLen AS LONG
   DIM PixCnt AS LONG
   PixelA$ = SPACE$(3)
   PixelB$ = SPACE$(3)

   GET #1, , PixelA$
   Ab% = ASC(MID$(PixelA$, 1, 1))
   Ag% = ASC(MID$(PixelA$, 2, 1))
   Ar% = ASC(MID$(PixelA$, 3, 1))
   A& = Ar% + Ag% * 256& + Ab% * 65536

   DO
      RunLen = RunLen + 1
      PixCnt = PixCnt + 1
     
      CALL Progress(PixCnt, 1& * thdr.xres * thdr.yres)

      GET #1, , PixelB$
      Bb% = ASC(MID$(PixelB$, 1, 1))
      Bg% = ASC(MID$(PixelB$, 2, 1))
      Br% = ASC(MID$(PixelB$, 3, 1))
      B& = Br% + Bg% * 256& + Bb% * 65536

      IF B& <> A& OR EOF(1) THEN
         IF RunLen <= 128 THEN
            RL$ = CHR$(RunLen + 127)
               IF DEBUG THEN PRINT "Less", ASC(RL$), PixCnt, RunLen
            PUT #2, , RL$: PUT #2, , PixelA$
         ELSE
            FOR i = 1 TO RunLen \ 128
               RL$ = CHR$(255)
                  IF DEBUG THEN PRINT ">", ASC(RL$), PixCnt, RunLen
               PUT #2, , RL$: PUT #2, , PixelA$
            NEXT
            IF RunLen MOD 128 THEN
               RL$ = CHR$((RunLen MOD 128) + 127)
                  IF DEBUG THEN PRINT "Mod", ASC(RL$), PixCnt, RunLen
               PUT #2, , RL$: PUT #2, , PixelA$
            END IF
         END IF
         RunLen = 0
      END IF

      PixelA$ = PixelB$
      Ab% = ASC(MID$(PixelA$, 1, 1))
      Ag% = ASC(MID$(PixelA$, 2, 1))
      Ar% = ASC(MID$(PixelA$, 3, 1))
      A& = Ar% + Ag% * 256& + Ab% * 65536

   LOOP WHILE PixCnt < 1& * thdr.xres * thdr.yres
END SUB

SUB PrintHeader
   SHARED tgafileI$, tgafileO$

   TwoColr 75
   PRINT "!Copyright (!C) 1995, Anthony D'Agostino"; SPACE$(29); " 72650,2377"

   TwoColr 7
   PRINT "Version 1.0", "This program is freeware"
   PRINT "Compress 24 bit TGA files with simple Run Length Encoding."

   PRINT
   PRINT "Reading file : "; tgafileI$,
   PRINT thdr.xres; "x"; thdr.yres; "x";
   PRINT ASC(thdr.bitsperpix); "bit"

   IF (thdr.tgatype <> 2) THEN
      PRINT : PRINT "This is a type"; thdr.tgatype; "file"
      PRINT "Already compressed?"
      END
   END IF

   PRINT "Writing file : "; tgafileO$
   PRINT
   PRINT
END SUB

SUB Progress (Counter&, maximum&)
   STATIC Established%
   DIM BARLEN AS INTEGER
   BARLEN = 40
   bground$ = CHR$(176)
   fground$ = CHR$(178)
   BarMod% = maximum& / BARLEN

   IF NOT Established% THEN                        ' Let's do this only once!
      TwoColr 14                                   ' foreground color
      PRINT SPACE$((80 - BARLEN) / 2);             ' center line
      PRINT STRING$((BARLEN), bground$);
      LOCATE , 1                                   ' go back
      PRINT SPACE$((80 - BARLEN) / 2);             ' center line for foregrnd
      TwoColr 15                                   ' background color
      Established% = TRUE                          ' Set this so we don't do
   END IF                                          ' it on subsequent calls

   IF (Counter& MOD BarMod% = 0) THEN PRINT fground$;
END SUB

SUB TwoColr (Attr%)
   FG% = (Attr% - (Attr% AND 128)) MOD 16 + (Attr% AND 128) \ 8
   Bg% = (Attr% - (Attr% AND 128)) \ 16
   COLOR FG%, Bg%
END SUB

